﻿using System;
//using System.Collections.Generic;
//using System.ComponentModel;
//using System.Data;
//using System.Drawing;
//using System.Linq;
//using System.Text;
using System.Windows.Forms;
using System.ServiceModel; // System.ServiceModel.dll -- ServiceHost
using System.ServiceModel.Description; // System.ServiceModel.dll

namespace WCFMathServiceWinFormHost
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    static ServiceHost serviceHost = null;
    private void button1_Click(object sender, EventArgs e)
    {
      try
      {
        string address = "http://localhost:8000/MyWCFMathService/Service";
        //string address = "http://vte021:8000/MyWCFMathService/Service";
        Uri baseAddress = new Uri(address);
        serviceHost = new ServiceHost(typeof(MathService), baseAddress);
        serviceHost.AddServiceEndpoint(typeof(IMathService), new WSHttpBinding(SecurityMode.None), "MathService");
        //serviceHost.AddServiceEndpoint(typeof(IMathService), new BasicHttpBinding(), "MathService");
        ServiceMetadataBehavior smb = new ServiceMetadataBehavior();
        smb.HttpGetEnabled = true;
        serviceHost.Description.Behaviors.Add(smb);
        listBox1.Items.Add("");
        listBox1.Items.Add("Attempting to start WCF MathService");
        listBox1.Items.Add("at " + address);
        listBox1.Items.Add("");
        listBox1.Items.Add(". . . ");
        listBox1.Items.Add("");
        serviceHost.Open();
        //CommunicationState cs = serviceHost.State;
        int count = 0;
        while (serviceHost.State != CommunicationState.Opened && count < 50)
        {
          listBox1.Items.Add(" . ");
          System.Threading.Thread.Sleep(1);
          ++count;
        }
        if (serviceHost.State == CommunicationState.Opened)
          listBox1.Items.Add("WCF MathService is started");
        else
          throw new Exception("Unable to start WCF MathService in a timely manner");

      }
      catch (Exception ex)
      {
        listBox1.Items.Add(ex.Message);
      }
    } // button1_Click()

    private void button2_Click(object sender, EventArgs e)
    {
      try
      {
        listBox1.Items.Add("");
        listBox1.Items.Add("Attempting to stop MathService");
        listBox1.Items.Add(". . . ");
        int count = 0;
        serviceHost.Close();
        while (serviceHost.State != CommunicationState.Closed && count < 50)
        {
          System.Threading.Thread.Sleep(100);
          ++count;
        }
        if (serviceHost.State == CommunicationState.Closed)
          listBox1.Items.Add("WCF MathService is stopped" + Environment.NewLine);
        else
          throw new Exception("Unable to stop WCF MathService in a timely manner");
      }
      catch (Exception ex)
      {
        Console.WriteLine("Fatal error: " + ex.Message);
        serviceHost.Abort();
      }
    }
  } // Form1

  [ServiceContract]
  public interface IMathService
  {
    [OperationContract]
    double Sum(double x, double y);
  }
  public class MathService : IMathService
  {
    public double Sum(double x, double y)
    {
      double answer = x + y;
      return answer;
    }
  }

  // ===================

  



  // ===================

} // ns
